diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/flow-monitor/model/ipv4-flow-classifier.cc ns-3.38/src/flow-monitor/model/ipv4-flow-classifier.cc
--- ns-3.37/src/flow-monitor/model/ipv4-flow-classifier.cc	2022-11-01 17:37:24.487395000 -0700
+++ ns-3.38/src/flow-monitor/model/ipv4-flow-classifier.cc	2023-03-16 20:54:23.608868600 -0700
@@ -124,7 +124,7 @@
     }
 
     // we rely on the fact that for both TCP and UDP the ports are
-    // carried in the first 4 octects.
+    // carried in the first 4 octets.
     // This allows to read the ports even on fragmented packets
     // not carrying a full TCP or UDP header.
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/flow-monitor/model/ipv4-flow-probe.cc ns-3.38/src/flow-monitor/model/ipv4-flow-probe.cc
--- ns-3.37/src/flow-monitor/model/ipv4-flow-probe.cc	2022-11-01 17:37:24.487395000 -0700
+++ ns-3.38/src/flow-monitor/model/ipv4-flow-probe.cc	2023-03-16 20:54:23.608868600 -0700
@@ -61,7 +61,7 @@
     void Print(std::ostream& os) const override;
     Ipv4FlowProbeTag();
     /**
-     * \brief Consructor
+     * \brief Constructor
      * \param flowId the flow identifier
      * \param packetId the packet identifier
      * \param packetSize the packet size
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/flow-monitor/model/ipv6-flow-classifier.cc ns-3.38/src/flow-monitor/model/ipv6-flow-classifier.cc
--- ns-3.37/src/flow-monitor/model/ipv6-flow-classifier.cc	2022-11-01 17:37:24.487395000 -0700
+++ ns-3.38/src/flow-monitor/model/ipv6-flow-classifier.cc	2023-03-16 20:54:23.608868600 -0700
@@ -125,7 +125,7 @@
     }
 
     // we rely on the fact that for both TCP and UDP the ports are
-    // carried in the first 4 octects.
+    // carried in the first 4 octets.
     // This allows to read the ports even on fragmented packets
     // not carrying a full TCP or UDP header.
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/flow-monitor/model/ipv6-flow-probe.cc ns-3.38/src/flow-monitor/model/ipv6-flow-probe.cc
--- ns-3.37/src/flow-monitor/model/ipv6-flow-probe.cc	2022-11-01 17:37:24.487395000 -0700
+++ ns-3.38/src/flow-monitor/model/ipv6-flow-probe.cc	2023-03-16 20:54:23.608868600 -0700
@@ -62,7 +62,7 @@
     void Print(std::ostream& os) const override;
     Ipv6FlowProbeTag();
     /**
-     * \brief Consructor
+     * \brief Constructor
      * \param flowId the flow identifier
      * \param packetId the packet identifier
      * \param packetSize the packet size
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/CMakeLists.txt ns-3.38/src/internet/CMakeLists.txt
--- ns-3.37/src/internet/CMakeLists.txt	2022-11-01 17:37:24.491395000 -0700
+++ ns-3.38/src/internet/CMakeLists.txt	2023-03-16 20:54:23.612868500 -0700
@@ -79,7 +79,6 @@
     model/ipv6.cc
     model/loopback-net-device.cc
     model/ndisc-cache.cc
-    model/pending-data.cc
     model/rip-header.cc
     model/rip.cc
     model/ripng-header.cc
@@ -119,7 +118,7 @@
     model/tcp-tx-item.cc
     model/tcp-vegas.cc
     model/tcp-veno.cc
-    model/tcp-westwood.cc
+    model/tcp-westwood-plus.cc
     model/tcp-yeah.cc
     model/udp-header.cc
     model/udp-l4-protocol.cc
@@ -244,7 +243,7 @@
     model/tcp-tx-item.h
     model/tcp-vegas.h
     model/tcp-veno.h
-    model/tcp-westwood.h
+    model/tcp-westwood-plus.h
     model/tcp-yeah.h
     model/udp-header.h
     model/udp-l4-protocol.h
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/helper/ipv4-routing-helper.cc ns-3.38/src/internet/helper/ipv4-routing-helper.cc
--- ns-3.37/src/internet/helper/ipv4-routing-helper.cc	2022-11-01 17:37:24.495395200 -0700
+++ ns-3.38/src/internet/helper/ipv4-routing-helper.cc	2023-03-16 20:54:23.612868500 -0700
@@ -183,7 +183,7 @@
 
         *os << "ARP Cache of node ";
         std::string found = Names::FindName(node);
-        if (Names::FindName(node) != "")
+        if (!Names::FindName(node).empty())
         {
             *os << found;
         }
@@ -217,7 +217,7 @@
 
         *os << "ARP Cache of node ";
         std::string found = Names::FindName(node);
-        if (Names::FindName(node) != "")
+        if (!Names::FindName(node).empty())
         {
             *os << found;
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/helper/ipv4-routing-helper.h ns-3.38/src/internet/helper/ipv4-routing-helper.h
--- ns-3.37/src/internet/helper/ipv4-routing-helper.h	2022-11-01 17:37:24.495395200 -0700
+++ ns-3.38/src/internet/helper/ipv4-routing-helper.h	2023-03-16 20:54:23.612868500 -0700
@@ -284,15 +284,6 @@
                                    Time::Unit unit = Time::S);
 };
 
-/**
- * \brief Request a specified routing protocol &lt;T&gt; from Ipv4RoutingProtocol protocol
- *
- * If protocol is Ipv4ListRouting, then protocol will be searched in the list,
- * otherwise a simple DynamicCast will be performed
- *
- * \param protocol Smart pointer to Ipv4RoutingProtocol object
- * \return a Smart Pointer to the requested protocol (zero if the protocol can't be found)
- */
 template <class T>
 Ptr<T>
 Ipv4RoutingHelper::GetRouting(Ptr<Ipv4RoutingProtocol> protocol)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/helper/ipv6-routing-helper.cc ns-3.38/src/internet/helper/ipv6-routing-helper.cc
--- ns-3.37/src/internet/helper/ipv6-routing-helper.cc	2022-11-01 17:37:24.495395200 -0700
+++ ns-3.38/src/internet/helper/ipv6-routing-helper.cc	2023-03-16 20:54:23.612868500 -0700
@@ -185,7 +185,7 @@
 
         *os << "NDISC Cache of node ";
         std::string found = Names::FindName(node);
-        if (Names::FindName(node) != "")
+        if (!Names::FindName(node).empty())
         {
             *os << found;
         }
@@ -219,7 +219,7 @@
 
         *os << "NDISC Cache of node ";
         std::string found = Names::FindName(node);
-        if (Names::FindName(node) != "")
+        if (!Names::FindName(node).empty())
         {
             *os << found;
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/helper/ipv6-routing-helper.h ns-3.38/src/internet/helper/ipv6-routing-helper.h
--- ns-3.37/src/internet/helper/ipv6-routing-helper.h	2022-11-01 17:37:24.495395200 -0700
+++ ns-3.38/src/internet/helper/ipv6-routing-helper.h	2023-03-16 20:54:23.612868500 -0700
@@ -284,15 +284,6 @@
                                      Time::Unit unit = Time::S);
 };
 
-/**
- * \brief Request a specified routing protocol &lt;T&gt; from Ipv6RoutingProtocol protocol
- *
- * If protocol is Ipv6ListRouting, then protocol will be searched in the list,
- * otherwise a simple DynamicCast will be performed
- *
- * \param protocol Smart pointer to Ipv6RoutingProtocol object
- * \return a Smart Pointer to the requested protocol (zero if the protocol can't be found)
- */
 template <class T>
 Ptr<T>
 Ipv6RoutingHelper::GetRouting(Ptr<Ipv6RoutingProtocol> protocol)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/helper/neighbor-cache-helper.cc ns-3.38/src/internet/helper/neighbor-cache-helper.cc
--- ns-3.37/src/internet/helper/neighbor-cache-helper.cc	2022-11-01 17:37:24.495395200 -0700
+++ ns-3.38/src/internet/helper/neighbor-cache-helper.cc	2023-03-16 20:54:23.612868500 -0700
@@ -64,16 +64,36 @@
     {
         Ptr<NetDevice> netDevice = channel->GetDevice(i);
         Ptr<Node> node = netDevice->GetNode();
-        int32_t ipv4InterfaceIndex = node->GetObject<Ipv4>()->GetInterfaceForDevice(netDevice);
-        int32_t ipv6InterfaceIndex = node->GetObject<Ipv6>()->GetInterfaceForDevice(netDevice);
+
+        int32_t ipv4InterfaceIndex = -1;
+        if (node->GetObject<Ipv4>())
+        {
+            ipv4InterfaceIndex = node->GetObject<Ipv4>()->GetInterfaceForDevice(netDevice);
+        }
+        int32_t ipv6InterfaceIndex = -1;
+        if (node->GetObject<Ipv6>())
+        {
+            ipv6InterfaceIndex = node->GetObject<Ipv6>()->GetInterfaceForDevice(netDevice);
+        }
+
         for (std::size_t j = 0; j < channel->GetNDevices(); ++j)
         {
             Ptr<NetDevice> neighborDevice = channel->GetDevice(j);
             Ptr<Node> neighborNode = neighborDevice->GetNode();
-            int32_t ipv4NeighborInterfaceIndex =
-                neighborNode->GetObject<Ipv4>()->GetInterfaceForDevice(neighborDevice);
-            int32_t ipv6NeighborInterfaceIndex =
-                neighborNode->GetObject<Ipv6>()->GetInterfaceForDevice(neighborDevice);
+
+            int32_t ipv4NeighborInterfaceIndex = -1;
+            if (neighborNode->GetObject<Ipv4>())
+            {
+                ipv4NeighborInterfaceIndex =
+                    neighborNode->GetObject<Ipv4>()->GetInterfaceForDevice(neighborDevice);
+            }
+            int32_t ipv6NeighborInterfaceIndex = -1;
+            if (neighborNode->GetObject<Ipv6>())
+            {
+                ipv6NeighborInterfaceIndex =
+                    neighborNode->GetObject<Ipv6>()->GetInterfaceForDevice(neighborDevice);
+            }
+
             if (neighborDevice != netDevice)
             {
                 if (ipv4InterfaceIndex != -1)
@@ -114,16 +134,36 @@
         Ptr<NetDevice> netDevice = c.Get(i);
         Ptr<Channel> channel = netDevice->GetChannel();
         Ptr<Node> node = netDevice->GetNode();
-        int32_t ipv4InterfaceIndex = node->GetObject<Ipv4>()->GetInterfaceForDevice(netDevice);
-        int32_t ipv6InterfaceIndex = node->GetObject<Ipv6>()->GetInterfaceForDevice(netDevice);
+
+        int32_t ipv4InterfaceIndex = -1;
+        if (node->GetObject<Ipv4>())
+        {
+            ipv4InterfaceIndex = node->GetObject<Ipv4>()->GetInterfaceForDevice(netDevice);
+        }
+        int32_t ipv6InterfaceIndex = -1;
+        if (node->GetObject<Ipv6>())
+        {
+            ipv6InterfaceIndex = node->GetObject<Ipv6>()->GetInterfaceForDevice(netDevice);
+        }
+
         for (std::size_t j = 0; j < channel->GetNDevices(); ++j)
         {
             Ptr<NetDevice> neighborDevice = channel->GetDevice(j);
             Ptr<Node> neighborNode = neighborDevice->GetNode();
-            int32_t ipv4NeighborInterfaceIndex =
-                neighborNode->GetObject<Ipv4>()->GetInterfaceForDevice(neighborDevice);
-            int32_t ipv6NeighborInterfaceIndex =
-                neighborNode->GetObject<Ipv6>()->GetInterfaceForDevice(neighborDevice);
+
+            int32_t ipv4NeighborInterfaceIndex = -1;
+            if (neighborNode->GetObject<Ipv4>())
+            {
+                ipv4NeighborInterfaceIndex =
+                    neighborNode->GetObject<Ipv4>()->GetInterfaceForDevice(neighborDevice);
+            }
+            int32_t ipv6NeighborInterfaceIndex = -1;
+            if (neighborNode->GetObject<Ipv6>())
+            {
+                ipv6NeighborInterfaceIndex =
+                    neighborNode->GetObject<Ipv6>()->GetInterfaceForDevice(neighborDevice);
+            }
+
             if (neighborDevice != netDevice)
             {
                 if (ipv4InterfaceIndex != -1)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/arp-cache.cc ns-3.38/src/internet/model/arp-cache.cc
--- ns-3.37/src/internet/model/arp-cache.cc	2022-11-01 17:37:24.495395200 -0700
+++ ns-3.38/src/internet/model/arp-cache.cc	2023-03-16 20:54:23.616868500 -0700
@@ -269,7 +269,7 @@
     {
         *os << i->first << " dev ";
         std::string found = Names::FindName(m_device);
-        if (Names::FindName(m_device) != "")
+        if (!Names::FindName(m_device).empty())
         {
             *os << found;
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/global-route-manager-impl.cc ns-3.38/src/internet/model/global-route-manager-impl.cc
--- ns-3.37/src/internet/model/global-route-manager-impl.cc	2022-11-01 17:37:24.495395200 -0700
+++ ns-3.38/src/internet/model/global-route-manager-impl.cc	2023-03-16 20:54:23.616868500 -0700
@@ -150,7 +150,7 @@
     }
 
     // delete children
-    while (m_children.size() > 0)
+    while (!m_children.empty())
     {
         // pop out children one by one. Some children may disappear
         // when deleting some other children in the list. As a result,
@@ -347,7 +347,7 @@
 
     // discard all exit direction currently associated with this vertex,
     // and copy all the exit directions from the given vertex
-    if (m_ecmpRootExits.size() > 0)
+    if (!m_ecmpRootExits.empty())
     {
         NS_LOG_WARN("x root exit directions in this vertex are going to be discarded");
     }
@@ -1137,7 +1137,7 @@
         // Above, when we were considering the root node, we calculated the next hop
         // address and outgoing interface required to get off of the root network.
         // At this point, we are further away from the root network along one of the
-        // (shortest) paths.  So the next hop and outoing interface remain the same
+        // (shortest) paths.  So the next hop and outgoing interface remain the same
         // (are inherited).
         //
         w->InheritAllRootExitDirections(v);
@@ -1702,7 +1702,7 @@
 
     NS_ASSERT_MSG(m_spfroot, "GlobalRouteManagerImpl::SPFIntraAddStub (): Root pointer not set");
 
-    // XXX simplifed logic for the moment.  There are two cases to consider:
+    // XXX simplified logic for the moment.  There are two cases to consider:
     // 1) the stub network is on this router; do nothing for now
     //    (already handled above)
     // 2) the stub network is on a remote router, so I should use the
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/global-router-interface.cc ns-3.38/src/internet/model/global-router-interface.cc
--- ns-3.37/src/internet/model/global-router-interface.cc	2022-11-01 17:37:24.495395200 -0700
+++ ns-3.38/src/internet/model/global-router-interface.cc	2023-03-16 20:54:23.616868500 -0700
@@ -272,7 +272,7 @@
 GlobalRoutingLSA::IsEmpty() const
 {
     NS_LOG_FUNCTION(this);
-    return m_linkRecords.size() == 0;
+    return m_linkRecords.empty();
 }
 
 GlobalRoutingLSA::LSType
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/icmpv4-l4-protocol.cc ns-3.38/src/internet/model/icmpv4-l4-protocol.cc
--- ns-3.37/src/internet/model/icmpv4-l4-protocol.cc	2022-11-01 17:37:24.495395200 -0700
+++ ns-3.38/src/internet/model/icmpv4-l4-protocol.cc	2023-03-16 20:54:23.616868500 -0700
@@ -300,9 +300,35 @@
     p->RemoveHeader(icmp);
     switch (icmp.GetType())
     {
-    case Icmpv4Header::ICMPV4_ECHO:
-        HandleEcho(p, icmp, header.GetSource(), header.GetDestination());
+    case Icmpv4Header::ICMPV4_ECHO: {
+        Ipv4Address dst = header.GetDestination();
+        // We could have received an Echo request to a broadcast-type address.
+        if (dst.IsBroadcast())
+        {
+            Ipv4Address src = header.GetSource();
+            for (uint32_t index = 0; index < incomingInterface->GetNAddresses(); index++)
+            {
+                Ipv4InterfaceAddress addr = incomingInterface->GetAddress(index);
+                if (addr.IsInSameSubnet(src))
+                {
+                    dst = addr.GetAddress();
+                }
+            }
+        }
+        else
+        {
+            for (uint32_t index = 0; index < incomingInterface->GetNAddresses(); index++)
+            {
+                Ipv4InterfaceAddress addr = incomingInterface->GetAddress(index);
+                if (dst == addr.GetBroadcast())
+                {
+                    dst = addr.GetAddress();
+                }
+            }
+        }
+        HandleEcho(p, icmp, header.GetSource(), dst);
         break;
+    }
     case Icmpv4Header::ICMPV4_DEST_UNREACH:
         HandleDestUnreach(p, icmp, header.GetSource(), header.GetDestination());
         break;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/icmpv6-header.cc ns-3.38/src/internet/model/icmpv6-header.cc
--- ns-3.37/src/internet/model/icmpv6-header.cc	2022-11-01 17:37:24.495395200 -0700
+++ ns-3.38/src/internet/model/icmpv6-header.cc	2023-03-16 20:54:23.616868500 -0700
@@ -657,19 +657,6 @@
     m_flagH = h;
 }
 
-uint8_t
-Icmpv6RA::GetFlags() const
-{
-    NS_LOG_FUNCTION(this);
-    return 0;
-}
-
-void
-Icmpv6RA::SetFlags(uint8_t f)
-{
-    NS_LOG_FUNCTION(this << static_cast<uint32_t>(f));
-}
-
 void
 Icmpv6RA::Print(std::ostream& os) const
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/icmpv6-header.h ns-3.38/src/internet/model/icmpv6-header.h
--- ns-3.37/src/internet/model/icmpv6-header.h	2022-11-01 17:37:24.495395200 -0700
+++ ns-3.38/src/internet/model/icmpv6-header.h	2023-03-16 20:54:23.616868500 -0700
@@ -683,20 +683,6 @@
     void Print(std::ostream& os) const override;
 
     /**
-     * \brief Getflags.
-     * \return the flags value
-     */
-    NS_DEPRECATED_3_34
-    uint8_t GetFlags() const;
-
-    /**
-     * \brief Setflags.
-     * \param f the flags value
-     */
-    NS_DEPRECATED_3_34
-    void SetFlags(uint8_t f);
-
-    /**
      * \brief Get the serialized size.
      * \return serialized size
      */
@@ -1474,13 +1460,13 @@
     /**
      * \brief Icmpv6 Option Prefix Information flag field values
      */
-    typedef enum
+    enum Flags_t
     {
         NONE = 0,         //!< No flags
         ROUTERADDR = 32,  //!< Router Address
         AUTADDRCONF = 64, //!< Autonomous Address Configuration
         ONLINK = 128      //!< On-link
-    } Flags_t;
+    };
 
     /**
      * \brief Get the prefix length.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/icmpv6-l4-protocol.cc ns-3.38/src/internet/model/icmpv6-l4-protocol.cc
--- ns-3.37/src/internet/model/icmpv6-l4-protocol.cc	2022-11-01 17:37:24.495395200 -0700
+++ ns-3.38/src/internet/model/icmpv6-l4-protocol.cc	2023-03-16 20:54:23.616868500 -0700
@@ -703,7 +703,7 @@
             }
             break;
         default:
-            /* unknow option, quit */
+            /* unknown option, quit */
             next = false;
         }
         if (packet->GetSize() == 0)
@@ -1383,7 +1383,7 @@
         }
         else
         {
-            // Following RS transmission - adding further jitter is unnecesary.
+            // Following RS transmission - adding further jitter is unnecessary.
             rsTimeout = m_rsPrevRetransmissionTimeout * (2 + m_rsRetransmissionJitter->GetValue());
             if (rsTimeout > m_rsMaxRetransmissionTime)
             {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/ip-l4-protocol.h ns-3.38/src/internet/model/ip-l4-protocol.h
--- ns-3.37/src/internet/model/ip-l4-protocol.h	2022-11-01 17:37:24.495395200 -0700
+++ ns-3.38/src/internet/model/ip-l4-protocol.h	2023-03-16 20:54:23.616868500 -0700
@@ -83,9 +83,9 @@
      * \param incomingInterface the Ipv4Interface on which the packet arrived
      * \returns Rx status code
      */
-    virtual enum RxStatus Receive(Ptr<Packet> p,
-                                  const Ipv4Header& header,
-                                  Ptr<Ipv4Interface> incomingInterface) = 0;
+    virtual RxStatus Receive(Ptr<Packet> p,
+                             const Ipv4Header& header,
+                             Ptr<Ipv4Interface> incomingInterface) = 0;
 
     /**
      * \brief Called from lower-level layers to send the packet up in the stack.
@@ -94,9 +94,9 @@
      * \param incomingInterface the Ipv6Interface on which the packet arrived
      * \returns Rx status code
      */
-    virtual enum RxStatus Receive(Ptr<Packet> p,
-                                  const Ipv6Header& header,
-                                  Ptr<Ipv6Interface> incomingInterface) = 0;
+    virtual RxStatus Receive(Ptr<Packet> p,
+                             const Ipv6Header& header,
+                             Ptr<Ipv6Interface> incomingInterface) = 0;
 
     /**
      * \brief Called from lower-level layers to send the ICMP packet up in the stack.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/ipv4-end-point.cc ns-3.38/src/internet/model/ipv4-end-point.cc
--- ns-3.37/src/internet/model/ipv4-end-point.cc	2022-11-01 17:37:24.495395200 -0700
+++ ns-3.38/src/internet/model/ipv4-end-point.cc	2023-03-16 20:54:23.616868500 -0700
@@ -166,7 +166,7 @@
 }
 
 bool
-Ipv4EndPoint::IsRxEnabled()
+Ipv4EndPoint::IsRxEnabled() const
 {
     return m_rxEnabled;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/ipv4-end-point.h ns-3.38/src/internet/model/ipv4-end-point.h
--- ns-3.37/src/internet/model/ipv4-end-point.h	2022-11-01 17:37:24.495395200 -0700
+++ ns-3.38/src/internet/model/ipv4-end-point.h	2023-03-16 20:54:23.616868500 -0700
@@ -187,7 +187,7 @@
      * \brief Checks if the endpoint can receive packets.
      * \returns true if the endpoint can receive packets.
      */
-    bool IsRxEnabled();
+    bool IsRxEnabled() const;
 
   private:
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/ipv4-global-routing.cc ns-3.38/src/internet/model/ipv4-global-routing.cc
--- ns-3.37/src/internet/model/ipv4-global-routing.cc	2022-11-01 17:37:24.499395100 -0700
+++ ns-3.38/src/internet/model/ipv4-global-routing.cc	2023-03-16 20:54:23.616868500 -0700
@@ -155,7 +155,7 @@
             NS_LOG_LOGIC(allRoutes.size() << "Found global host route" << *i);
         }
     }
-    if (allRoutes.size() == 0) // if no host route is found
+    if (allRoutes.empty()) // if no host route is found
     {
         NS_LOG_LOGIC("Number of m_networkRoutes" << m_networkRoutes.size());
         for (NetworkRoutesI j = m_networkRoutes.begin(); j != m_networkRoutes.end(); j++)
@@ -177,7 +177,7 @@
             }
         }
     }
-    if (allRoutes.size() == 0) // consider external if no host/network found
+    if (allRoutes.empty()) // consider external if no host/network found
     {
         for (ASExternalRoutesI k = m_ASexternalRoutes.begin(); k != m_ASexternalRoutes.end(); k++)
         {
@@ -199,7 +199,7 @@
             }
         }
     }
-    if (allRoutes.size() > 0) // if route(s) is found
+    if (!allRoutes.empty()) // if route(s) is found
     {
         // pick up one of the routes uniformly at random if random
         // ECMP routing is enabled, or always select the first route
@@ -421,7 +421,7 @@
             // Use not implemented
             *os << "-"
                 << "   ";
-            if (Names::FindName(m_ipv4->GetNetDevice(route.GetInterface())) != "")
+            if (!Names::FindName(m_ipv4->GetNetDevice(route.GetInterface())).empty())
             {
                 *os << Names::FindName(m_ipv4->GetNetDevice(route.GetInterface()));
             }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/ipv4-interface.cc ns-3.38/src/internet/model/ipv4-interface.cc
--- ns-3.37/src/internet/model/ipv4-interface.cc	2022-11-01 17:37:24.499395100 -0700
+++ ns-3.38/src/internet/model/ipv4-interface.cc	2023-03-16 20:54:23.616868500 -0700
@@ -387,7 +387,7 @@
 {
     NS_LOG_FUNCTION(this << address);
 
-    if (address == address.GetLoopback())
+    if (address == Ipv4Address::GetLoopback())
     {
         NS_LOG_WARN("Cannot remove loopback address.");
         return Ipv4InterfaceAddress();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/ipv4-l3-protocol.cc ns-3.38/src/internet/model/ipv4-l3-protocol.cc
--- ns-3.37/src/internet/model/ipv4-l3-protocol.cc	2022-11-01 17:37:24.499395100 -0700
+++ ns-3.38/src/internet/model/ipv4-l3-protocol.cc	2023-03-16 20:54:23.616868500 -0700
@@ -1395,7 +1395,7 @@
         NS_LOG_LOGIC(
             "Interface "
             << int(i)
-            << " is set to be down for IPv4. Reason: not respecting minimum IPv4 MTU (68 octects)");
+            << " is set to be down for IPv4. Reason: not respecting minimum IPv4 MTU (68 octets)");
     }
 }
 
@@ -1650,7 +1650,7 @@
 {
     NS_LOG_FUNCTION(this);
 
-    bool ret = !m_moreFragment && m_fragments.size() > 0;
+    bool ret = !m_moreFragment && !m_fragments.empty();
 
     if (ret)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/ipv4-raw-socket-impl.cc ns-3.38/src/internet/model/ipv4-raw-socket-impl.cc
--- ns-3.37/src/internet/model/ipv4-raw-socket-impl.cc	2022-11-01 17:37:24.499395100 -0700
+++ ns-3.38/src/internet/model/ipv4-raw-socket-impl.cc	2023-03-16 20:54:23.620868400 -0700
@@ -275,10 +275,19 @@
         p->AddPacketTag(tag);
     }
 
+    Ptr<NetDevice> boundNetDevice = m_boundnetdevice;
+
+    if (!m_src.IsAny())
+    {
+        int32_t index = ipv4->GetInterfaceForAddress(m_src);
+        NS_ASSERT(index >= 0);
+        boundNetDevice = ipv4->GetNetDevice(index);
+    }
+
     bool subnetDirectedBroadcast = false;
-    if (m_boundnetdevice)
+    if (boundNetDevice)
     {
-        uint32_t iif = ipv4->GetInterfaceForDevice(m_boundnetdevice);
+        uint32_t iif = ipv4->GetInterfaceForDevice(boundNetDevice);
         for (uint32_t j = 0; j < ipv4->GetNAddresses(iif); j++)
         {
             Ipv4InterfaceAddress ifAddr = ipv4->GetAddress(iif, j);
@@ -291,7 +300,6 @@
 
     if (dst.IsBroadcast() || subnetDirectedBroadcast)
     {
-        Ptr<NetDevice> boundNetDevice = m_boundnetdevice;
         if (ipv4->GetNInterfaces() == 1)
         {
             boundNetDevice = ipv4->GetNetDevice(0);
@@ -312,6 +320,7 @@
             route->SetSource(src);
             route->SetDestination(dst);
             route->SetOutputDevice(boundNetDevice);
+            route->SetGateway("0.0.0.0");
             ipv4->Send(p, route->GetSource(), dst, m_protocol, route);
         }
         else
@@ -324,6 +333,7 @@
             route->SetSource(src);
             route->SetDestination(dst);
             route->SetOutputDevice(boundNetDevice);
+            route->SetGateway("0.0.0.0");
             ipv4->SendWithHeader(p, header, route);
         }
         NotifyDataSent(pktSize);
@@ -413,7 +423,7 @@
     {
         return nullptr;
     }
-    struct Data data = m_recv.front();
+    Data data = m_recv.front();
     m_recv.pop_front();
     InetSocketAddress inet = InetSocketAddress(data.fromIp, data.fromProtocol);
     fromAddress = inet;
@@ -501,7 +511,7 @@
             }
         }
         copy->AddHeader(ipHeader);
-        struct Data data;
+        Data data;
         data.packet = copy;
         data.fromIp = ipHeader.GetSource();
         data.fromProtocol = ipHeader.GetProtocol();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/ipv4-static-routing.cc ns-3.38/src/internet/model/ipv4-static-routing.cc
--- ns-3.37/src/internet/model/ipv4-static-routing.cc	2022-11-01 17:37:24.499395100 -0700
+++ ns-3.38/src/internet/model/ipv4-static-routing.cc	2023-03-16 20:54:23.620868400 -0700
@@ -756,7 +756,7 @@
             // Use not implemented
             *os << "-"
                 << "   ";
-            if (Names::FindName(m_ipv4->GetNetDevice(route.GetInterface())) != "")
+            if (!Names::FindName(m_ipv4->GetNetDevice(route.GetInterface())).empty())
             {
                 *os << Names::FindName(m_ipv4->GetNetDevice(route.GetInterface()));
             }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/ipv6-end-point.cc ns-3.38/src/internet/model/ipv6-end-point.cc
--- ns-3.37/src/internet/model/ipv6-end-point.cc	2022-11-01 17:37:24.499395100 -0700
+++ ns-3.38/src/internet/model/ipv6-end-point.cc	2023-03-16 20:54:23.620868400 -0700
@@ -61,7 +61,7 @@
 }
 
 uint16_t
-Ipv6EndPoint::GetLocalPort()
+Ipv6EndPoint::GetLocalPort() const
 {
     return m_localPort;
 }
@@ -79,7 +79,7 @@
 }
 
 uint16_t
-Ipv6EndPoint::GetPeerPort()
+Ipv6EndPoint::GetPeerPort() const
 {
     return m_peerPort;
 }
@@ -151,7 +151,7 @@
 }
 
 bool
-Ipv6EndPoint::IsRxEnabled()
+Ipv6EndPoint::IsRxEnabled() const
 {
     return m_rxEnabled;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/ipv6-end-point.h ns-3.38/src/internet/model/ipv6-end-point.h
--- ns-3.37/src/internet/model/ipv6-end-point.h	2022-11-01 17:37:24.499395100 -0700
+++ ns-3.38/src/internet/model/ipv6-end-point.h	2023-03-16 20:54:23.620868400 -0700
@@ -74,7 +74,7 @@
      * \brief Get the local port.
      * \return the local port
      */
-    uint16_t GetLocalPort();
+    uint16_t GetLocalPort() const;
 
     /**
      * \brief Set the local port.
@@ -92,7 +92,7 @@
      * \brief Get the peer port.
      * \return the peer port
      */
-    uint16_t GetPeerPort();
+    uint16_t GetPeerPort() const;
 
     /**
      * \brief Set the peer information (address and port).
@@ -191,7 +191,7 @@
      * \brief Checks if the endpoint can receive packets.
      * \returns true if the endpoint can receive packets.
      */
-    bool IsRxEnabled();
+    bool IsRxEnabled() const;
 
   private:
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/ipv6-extension.cc ns-3.38/src/internet/model/ipv6-extension.cc
--- ns-3.37/src/internet/model/ipv6-extension.cc	2022-11-01 17:37:24.499395100 -0700
+++ ns-3.38/src/internet/model/ipv6-extension.cc	2023-03-16 20:54:23.620868400 -0700
@@ -770,7 +770,7 @@
 bool
 Ipv6ExtensionFragment::Fragments::IsEntire() const
 {
-    bool ret = !m_moreFragment && m_packetFragments.size() > 0;
+    bool ret = !m_moreFragment && !m_packetFragments.empty();
 
     if (ret)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/ipv6-extension-header.cc ns-3.38/src/internet/model/ipv6-extension-header.cc
--- ns-3.37/src/internet/model/ipv6-extension-header.cc	2022-11-01 17:37:24.499395100 -0700
+++ ns-3.38/src/internet/model/ipv6-extension-header.cc	2023-03-16 20:54:23.620868400 -0700
@@ -216,7 +216,7 @@
 }
 
 uint32_t
-OptionField::GetOptionsOffset()
+OptionField::GetOptionsOffset() const
 {
     return m_optionsOffset;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/ipv6-extension-header.h ns-3.38/src/internet/model/ipv6-extension-header.h
--- ns-3.37/src/internet/model/ipv6-extension-header.h	2022-11-01 17:37:24.499395100 -0700
+++ ns-3.38/src/internet/model/ipv6-extension-header.h	2023-03-16 20:54:23.620868400 -0700
@@ -186,7 +186,7 @@
      * the extension header.
      * \return the offset from the start of the extension header
      */
-    uint32_t GetOptionsOffset();
+    uint32_t GetOptionsOffset() const;
 
     /**
      * \brief Get the buffer.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/ipv6-header.cc ns-3.38/src/internet/model/ipv6-header.cc
--- ns-3.37/src/internet/model/ipv6-header.cc	2022-11-01 17:37:24.499395100 -0700
+++ ns-3.38/src/internet/model/ipv6-header.cc	2023-03-16 20:54:23.620868400 -0700
@@ -108,48 +108,24 @@
     m_sourceAddress = src;
 }
 
-void
-Ipv6Header::SetSourceAddress(Ipv6Address src)
-{
-    SetSource(src);
-}
-
 Ipv6Address
 Ipv6Header::GetSource() const
 {
     return m_sourceAddress;
 }
 
-Ipv6Address
-Ipv6Header::GetSourceAddress() const
-{
-    return GetSource();
-}
-
 void
 Ipv6Header::SetDestination(Ipv6Address dst)
 {
     m_destinationAddress = dst;
 }
 
-void
-Ipv6Header::SetDestinationAddress(Ipv6Address dst)
-{
-    SetDestination(dst);
-}
-
 Ipv6Address
 Ipv6Header::GetDestination() const
 {
     return m_destinationAddress;
 }
 
-Ipv6Address
-Ipv6Header::GetDestinationAddress() const
-{
-    return GetDestination();
-}
-
 TypeId
 Ipv6Header::GetTypeId()
 {
